const config = require('config');
const BizResult = require('./BizResult')
const BizResultCode = require('./BaseResultCode');
const logger = require('./logger')('HeartbeatController.js');

const heartbeatService = require('./HeartbeatService');

class HeartbeatController {

    /**
     * heartbeat
     * @param {*} req       HTTP request
     * @param {*} res       HTTP response
     * @returns 
     */
    static async heartbeat(req, res) {

        heartbeatService.heartbeat()
        .then(result => {
            if (result) {
                res.send(BizResult.success(result));
            } else {
                res.send(BizResult.fail(BizResultCode.FOGGIE_SERVICE_UNAVAILABLE));
            }
         })
         .catch(err => { 
            res.send(BizResult.fail(BizResultCode.FOGGIE_SERVICE_UNAVAILABLE));
         });
    }
}
module.exports = HeartbeatController