const logger = require('./logger')('HeartbeatService.js');
const config = require('config');
const pow_proto = require('./grpc/pow');
const grpc = require('@grpc/grpc-js');

module.exports = {
    heartbeat: async () => {
        var grpcConfig = config.get('grpcConfig');
        var ip = grpcConfig.get("ip");
        var port = grpcConfig.get("port");
        var powClient = new pow_proto.PowService(ip + ':' + port, grpc.credentials.createInsecure());
        var hostIDReq = {
        }
        return new Promise((resolve, reject) => {
            powClient.GetHostID(hostIDReq, function (err, data) {
                if (err) {
                    logger.error('err:', err);
                    resolve(false);
                    return;
                }
                logger.info('grpc GetHostID, peerID:{}', data.peerID);
                resolve(data.peerID);
            });
        });
    }
}